Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -1763,1019 +3147,222 @@
     END SUBROUTINE usm_raytrace
     
-
-
-!------------------------------------------------------------------------------!
-!> Calculates radiation absorbed by box with given size and LAD.
-!>
-!> Simulates resol**2 rays (by equally spacing a bounding horizontal square
-!> conatining all possible rays that would cross the box) and calculates
-!> average transparency per ray. Returns fraction of absorbed radiation flux
-!> and area for which this fraction is effective.
-!------------------------------------------------------------------------------!
-    PURE SUBROUTINE usm_box_absorb(boxsize, resol, dens, uvec, area, absorb)
-        IMPLICIT NONE
-
-        REAL(wp), DIMENSION(3), INTENT(in) :: &
-            boxsize, &      !< z, y, x size of box in m
-            uvec            !< z, y, x unit vector of incoming flux
-        INTEGER(iwp), INTENT(in) :: &
-            resol           !< No. of rays in x and y dimensions
-        REAL(wp), INTENT(in) :: &
-            dens            !< box density (e.g. Leaf Area Density)
-        REAL(wp), INTENT(out) :: &
-            area, &         !< horizontal area for flux absorbtion
-            absorb          !< fraction of absorbed flux
-        REAL(wp) :: &
-            xshift, yshift, &
-            xmin, xmax, ymin, ymax, &
-            xorig, yorig, &
-            dx1, dy1, dz1, dx2, dy2, dz2, &
-            crdist, &
-            transp
-        INTEGER(iwp) :: &
-            i, j
-
-        xshift = uvec(3) / uvec(1) * boxsize(1)
-        xmin = min(0._wp, -xshift)
-        xmax = boxsize(3) + max(0._wp, -xshift)
-        yshift = uvec(2) / uvec(1) * boxsize(1)
-        ymin = min(0._wp, -yshift)
-        ymax = boxsize(2) + max(0._wp, -yshift)
-
-        transp = 0._wp
-        DO i = 1, resol
-            xorig = xmin + (xmax-xmin) * (i-.5_wp) / resol
-            DO j = 1, resol
-                yorig = ymin + (ymax-ymin) * (j-.5_wp) / resol
-
-                dz1 = 0._wp
-                dz2 = boxsize(1)/uvec(1)
-
-                IF ( uvec(2) > 0._wp ) THEN
-                    dy1 = -yorig             / uvec(2) !< crossing with y=0
-                    dy2 = (boxsize(2)-yorig) / uvec(2) !< crossing with y=boxsize(2)
-                ELSE IF (uvec(2) < 0._wp ) THEN
-                    dy1 = (boxsize(2)-yorig) / uvec(2) !< crossing with y=boxsize(2)
-                    dy2 = -yorig             / uvec(2) !< crossing with y=0
-                ELSE !uvec(2)==0
-                    dy1 = -huge(1._wp)
-                    dy2 = huge(1._wp)
-                ENDIF
-
-                IF ( uvec(3) > 0._wp ) THEN
-                    dx1 = -xorig             / uvec(3) !< crossing with x=0
-                    dx2 = (boxsize(3)-xorig) / uvec(3) !< crossing with x=boxsize(3)
-                ELSE IF (uvec(3) < 0._wp ) THEN
-                    dx1 = (boxsize(3)-xorig) / uvec(3) !< crossing with x=boxsize(3)
-                    dx2 = -xorig             / uvec(3) !< crossing with x=0
-                ELSE !uvec(1)==0
-                    dx1 = -huge(1._wp)
-                    dx2 = huge(1._wp)
-                ENDIF
-
-                crdist = max(0._wp, (min(dz2, dy2, dx2) - max(dz1, dy1, dx1)))
-                transp = transp + exp(-ext_coef * dens * crdist)
-            ENDDO
-        ENDDO
-        transp = transp / resol**2
-        area = (boxsize(3)+xshift)*(boxsize(2)+yshift)
-        absorb = 1._wp - transp
-        
-    END SUBROUTINE usm_box_absorb
-
-    
-!------------------------------------------------------------------------------!
-!> Finds first model boundary crossed by a ray
-!------------------------------------------------------------------------------!
-    PURE SUBROUTINE usm_find_boundary_face(origin, uvect, bdycross)
-        IMPLICIT NONE
-        REAL(wp), DIMENSION(3), INTENT(in)      :: origin    !< ray origin
-        REAL(wp), DIMENSION(3), INTENT(in)      :: uvect     !< ray unit vector
-        INTEGER(iwp), DIMENSION(4), INTENT(out) :: bdycross  !< found boundary crossing (d, z, y, x)
-        REAL(wp), DIMENSION(3)                  :: crossdist !< crossing distance
-        INTEGER(iwp), DIMENSION(3)              :: bdyd      !< boundary direction
-        REAL(wp)                                :: bdydim    !< 
-        REAL(wp)                                :: dist      !< 
-        INTEGER(iwp)                            :: seldim    !< found fist crossing index
-        INTEGER(iwp)                            :: d         !< 
-
-        bdydim = nzut + .5_wp !< top boundary
-        bdyd(1) = isky
-        crossdist(1) = (bdydim - origin(1)) / uvect(1)
-
-        IF ( uvect(2) >= 0._wp ) THEN
-            bdydim = ny + .5_wp !< north global boundary
-            bdyd(2) = inorthb
-        ELSE
-            bdydim = -.5_wp !< south global boundary
-            bdyd(2) = isouthb
-        ENDIF
-        crossdist(2) = (bdydim - origin(2)) / uvect(2)
-
-        IF ( uvect(3) >= 0._wp ) THEN
-            bdydim = nx + .5_wp !< east global boundary
-            bdyd(3) = ieastb
-        ELSE
-            bdydim = -.5_wp !< west global boundary
-            bdyd(3) = iwestb
-        ENDIF
-        crossdist(3) = (bdydim - origin(3)) / uvect(3)
-
-        seldim = minloc(crossdist, 1)
-        dist = crossdist(seldim)
-        d = bdyd(seldim)
-
-        bdycross(1) = d
-        bdycross(2:4) = NINT( origin(:) + uvect(:)*dist &
-                        + .5_wp * (/ kdir(d), jdir(d), idir(d) /) )
-    END SUBROUTINE
-
-
-!------------------------------------------------------------------------------!
-!> Determines whether two faces are oriented towards each other
-!------------------------------------------------------------------------------!
-    PURE LOGICAL FUNCTION usm_facing(x, y, z, d, x2, y2, z2, d2)
-        IMPLICIT NONE
-        INTEGER(iwp),   INTENT(in)  :: x, y, z, d, x2, y2, z2, d2
-      
-        usm_facing = .FALSE.
-        IF ( d==iroof .AND. d2==iroof ) RETURN
-        IF ( d==isky .AND. d2==isky ) RETURN
-        IF ( (d==isouth .OR. d==inorthb) .AND. (d2==isouth.OR.d2==inorthb) ) RETURN
-        IF ( (d==inorth .OR. d==isouthb) .AND. (d2==inorth.OR.d2==isouthb) ) RETURN
-        IF ( (d==iwest .OR. d==ieastb) .AND. (d2==iwest.OR.d2==ieastb) ) RETURN
-        IF ( (d==ieast .OR. d==iwestb) .AND. (d2==ieast.OR.d2==iwestb) ) RETURN
-
-        SELECT CASE (d)
-            CASE (iroof)                   !< ground, roof
-                IF ( z2 < z ) RETURN
-            CASE (isky)                    !< sky
-                IF ( z2 > z ) RETURN
-            CASE (isouth, inorthb)         !< south facing
-                IF ( y2 > y ) RETURN
-            CASE (inorth, isouthb)         !< north facing
-                IF ( y2 < y ) RETURN
-            CASE (iwest, ieastb)           !< west facing
-                IF ( x2 > x ) RETURN
-            CASE (ieast, iwestb)           !< east facing
-                IF ( x2 < x ) RETURN
-        END SELECT
-
-        SELECT CASE (d2)
-            CASE (iroof)                   !< ground, roof
-                IF ( z < z2 ) RETURN
-            CASE (isky)                    !< sky
-                IF ( z > z2 ) RETURN
-            CASE (isouth, inorthb)         !< south facing
-                IF ( y > y2 ) RETURN
-            CASE (inorth, isouthb)         !< north facing
-                IF ( y < y2 ) RETURN
-            CASE (iwest, ieastb)           !< west facing
-                IF ( x > x2 ) RETURN
-            CASE (ieast, iwestb)           !< east facing
-                IF ( x < x2 ) RETURN
-            CASE (-1)
-                CONTINUE
-        END SELECT
-
-        usm_facing = .TRUE.
-        
-    END FUNCTION usm_facing
-    
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> This subroutine calculates interaction of the solar radiation
-!> with urban surface and updates surface, roofs and walls heatfluxes.
-!> It also updates rad_sw_out and rad_lw_out.
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_radiation
-    
-        IMPLICIT NONE
-       
-        INTEGER(iwp)               :: i, j, k, kk, is, js, d, ku, refstep
-        INTEGER(iwp)               :: nzubl, nzutl, isurf, isurfsrc, isurf1, isvf, ipcgb
-        INTEGER(iwp), DIMENSION(4) :: bdycross
-        REAL(wp), DIMENSION(3,3)   :: mrot            !< grid rotation matrix (xyz)
-        REAL(wp), DIMENSION(3,0:9) :: vnorm           !< face direction normal vectors (xyz)
-        REAL(wp), DIMENSION(3)     :: sunorig         !< grid rotated solar direction unit vector (xyz)
-        REAL(wp), DIMENSION(3)     :: sunorig_grid    !< grid squashed solar direction unit vector (zyx)
-        REAL(wp), DIMENSION(0:9)   :: costheta        !< direct irradiance factor of solar angle
-        REAL(wp), DIMENSION(nzub:nzut) :: pchf_prep   !< precalculated factor for canopy temp tendency
-        REAL(wp), PARAMETER        :: alpha = 0._wp   !< grid rotation (TODO: add to namelist or remove)
-        REAL(wp)                   :: rx, ry, rz
-        REAL(wp)                   :: pc_box_area, pc_abs_frac, pc_abs_eff
-        INTEGER(iwp)               :: pc_box_dimshift !< transform for best accuracy
-        
-        
-        IF (plant_canopy) THEN
-            pchf_prep(:) = r_d * (hyp(nzub:nzut) / 100000.0_wp)**0.286_wp &
-                        / (cp * hyp(nzub:nzut) * dx*dy*dz) !< equals to 1 / (rho * c_p * Vbox * T)
-        ENDIF
-
-        sun_direction = .TRUE.
-        CALL calc_zenith  !< required also for diffusion radiation
-
-        !-- prepare rotated normal vectors and irradiance factor
-        vnorm(1,:) = idir(:)
-        vnorm(2,:) = jdir(:)
-        vnorm(3,:) = kdir(:)
-        mrot(1, :) = (/ cos(alpha), -sin(alpha), 0._wp /)
-        mrot(2, :) = (/ sin(alpha),  cos(alpha), 0._wp /)
-        mrot(3, :) = (/ 0._wp,       0._wp,      1._wp /)
-        sunorig = (/ sun_dir_lon, sun_dir_lat, zenith(0) /)
-        sunorig = matmul(mrot, sunorig)
-        DO d = 0, 9
-            costheta(d) = dot_product(sunorig, vnorm(:,d))
-        ENDDO
-        
-        IF (zenith(0) > 0) THEN
-            !-- now we will "squash" the sunorig vector by grid box size in
-            !-- each dimension, so that this new direction vector will allow us
-            !-- to traverse the ray path within grid coordinates directly
-            sunorig_grid = (/ sunorig(3)/dz, sunorig(2)/dy, sunorig(1)/dx /)
-            !-- sunorig_grid = sunorig_grid / norm2(sunorig_grid)
-            sunorig_grid = sunorig_grid / SQRT(SUM(sunorig_grid**2))
-
-            IF ( plant_canopy )  THEN
-               !-- precompute effective box depth with prototype Leaf Area Density
-               pc_box_dimshift = maxloc(sunorig, 1) - 1
-               CALL usm_box_absorb(cshift((/dx,dy,dz/), pc_box_dimshift),      &
-                                   60, prototype_lad,                          &
-                                   cshift(sunorig, pc_box_dimshift),           &
-                                   pc_box_area, pc_abs_frac)
-               pc_box_area = pc_box_area * sunorig(pc_box_dimshift+1) / sunorig(3)
-               pc_abs_eff = log(1._wp - pc_abs_frac) / prototype_lad
-            ENDIF
-        ENDIF
-        
-        !-- split diffusion and direct part of the solar downward radiation
-        !-- comming from radiation model and store it in 2D arrays
-        !-- rad_sw_in_diff, rad_sw_in_dir and rad_lw_in_diff
-        IF (split_diffusion_radiation) THEN
-            CALL usm_calc_diffusion_radiation
-        ELSE
-            rad_sw_in_diff = 0.0_wp
-            rad_sw_in_dir(:,:)  = rad_sw_in(0,:,:)
-            rad_lw_in_diff(:,:) = rad_lw_in(0,:,:)
-        ENDIF
-
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        !-- First pass: direct + diffuse irradiance
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        surfinswdir   = 0._wp
-        surfinswdif   = 0._wp
-        surfinlwdif   = 0._wp
-        surfins   = 0._wp
-        surfinl   = 0._wp
-        surfoutsl    = 0._wp
-        surfoutll    = 0._wp
-        
-        !-- Set up thermal radiation from surfaces
-        !-- emiss_surf is defined only for surfaces for which energy balance is calculated
-        surfoutll(startenergy:endenergy) = emiss_surf(startenergy:endenergy) * sigma_sb   &
-                                           * t_surf(startenergy:endenergy)**4
-        
-#if defined( __parallel )
-        !-- might be optimized and gather only values relevant for current processor
-        CALL MPI_AllGatherv(surfoutll, nenergy, MPI_REAL, &
-                            surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
-#else
-        surfoutl(:) = surfoutll(:)
-#endif
-        
-        isurf1 = -1   !< previous processed surface
-        DO isvf = 1, nsvfl
-            isurf = svfsurf(1, isvf)
-            k = surfl(iz, isurf)
-            j = surfl(iy, isurf)
-            i = surfl(ix, isurf)
-            isurfsrc = svfsurf(2, isvf)
-            IF ( zenith(0) > 0 .AND. isurf /= isurf1 ) THEN
-                !-- locate the virtual surface where the direct solar ray crosses domain boundary
-                !-- (once per target surface)
-                d = surfl(id, isurf)
-                rz = REAL(k, wp) - 0.5_wp * kdir(d)
-                ry = REAL(j, wp) - 0.5_wp * jdir(d)
-                rx = REAL(i, wp) - 0.5_wp * idir(d)
-                
-                CALL usm_find_boundary_face( (/ rz, ry, rx /), sunorig_grid, bdycross)
-                
-                isurf1 = isurf
-            ENDIF
-
-            IF ( surf(id, isurfsrc) >= isky ) THEN
-                !-- diffuse rad from boundary surfaces. Since it is a simply
-                !-- calculated value, it is not assigned to surfref(s/l),
-                !-- instead it is used directly here
-                !-- we consider the radiation from the radiation model falling on surface
-                !-- as the radiation falling on the top of urban layer into the place of the source surface
-                !-- we consider it as a very reasonable simplification which allow as avoid
-                !-- necessity of other global range arrays and some all to all mpi communication
-                surfinswdif(isurf) = surfinswdif(isurf) + rad_sw_in_diff(j,i) * svf(1,isvf) * svf(2,isvf)
-                                                                !< canopy shading is applied only to shortwave
-                surfinlwdif(isurf) = surfinlwdif(isurf) + rad_lw_in_diff(j,i) * svf(1,isvf)
-            ELSE
-                !-- for surface-to-surface factors we calculate thermal radiation in 1st pass
-                surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
-            ENDIF
-            
-            IF ( zenith(0) > 0 .AND. all( surf(:, isurfsrc) == bdycross ) ) THEN
-                !-- found svf between model boundary and the face => face isn't shaded
-                surfinswdir(isurf) = rad_sw_in_dir(j, i) &
-                    * costheta(surfl(id, isurf)) * svf(2,isvf) / zenith(0)
-
-            ENDIF
-        ENDDO
-
-        IF ( plant_canopy ) THEN
-        
-            pcbinsw(:) = 0._wp
-            pcbinlw(:) = 0._wp  !< will stay always 0 since we don't absorb lw anymore
-            !
-            !-- pcsf first pass
-            isurf1 = -1  !< previous processed pcgb
-            DO isvf = nsvfl+1, nsvfcsfl
-                ipcgb = svfsurf(1, isvf)
-                i = pcbl(ix,ipcgb)
-                j = pcbl(iy,ipcgb)
-                k = pcbl(iz,ipcgb)
-                isurfsrc = svfsurf(2, isvf)
-
-                IF ( zenith(0) > 0 .AND. ipcgb /= isurf1 ) THEN
-                    !-- locate the virtual surface where the direct solar ray crosses domain boundary
-                    !-- (once per target PC gridbox)
-                    rz = REAL(k, wp)
-                    ry = REAL(j, wp)
-                    rx = REAL(i, wp)
-                    CALL usm_find_boundary_face( (/ rz, ry, rx /), &
-                        sunorig_grid, bdycross)
-
-                    isurf1 = ipcgb
-                ENDIF
-
-                IF ( surf(id, isurfsrc) >= isky ) THEN
-                    !-- Diffuse rad from boundary surfaces. See comments for svf above.
-                    pcbinsw(ipcgb) = pcbinsw(ipcgb) + svf(1,isvf) * svf(2,isvf) * rad_sw_in_diff(j,i)
-                    !-- canopy shading is applied only to shortwave, therefore no absorbtion for lw
-                    !-- pcbinlw(ipcgb) = pcbinlw(ipcgb) + svf(1,isvf) * rad_lw_in_diff(j,i)
-                !ELSE
-                    !-- Thermal radiation in 1st pass
-                    !-- pcbinlw(ipcgb) = pcbinlw(ipcgb) + svf(1,isvf) * surfoutl(isurfsrc)
-                ENDIF
-
-                IF ( zenith(0) > 0 .AND. all( surf(:, isurfsrc) == bdycross ) ) THEN
-                    !-- found svf between model boundary and the pcgb => pcgb isn't shaded
-                    pc_abs_frac = 1._wp - exp(pc_abs_eff * lad_s(k,j,i))
-                    pcbinsw(ipcgb) = pcbinsw(ipcgb) &
-                        + rad_sw_in_dir(j, i) * pc_box_area * svf(2,isvf) * pc_abs_frac
-                ENDIF
-            ENDDO
-        ENDIF
-        surfins(startenergy:endenergy) = surfinswdir(startenergy:endenergy) + surfinswdif(startenergy:endenergy)
-        surfinl(startenergy:endenergy) = surfinl(startenergy:endenergy) + surfinlwdif(startenergy:endenergy)
-        surfinsw(:) = surfins(:)
-        surfinlw(:) = surfinl(:)
-        surfoutsw(:) = 0.0_wp
-        surfoutlw(:) = surfoutll(:)
-        surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
-                                      - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
-        
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        !-- Next passes - reflections
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        DO refstep = 1, nrefsteps
-        
-            surfoutsl(startenergy:endenergy) = albedo_surf(startenergy:endenergy) * surfins(startenergy:endenergy)
-            !-- for non-transparent surfaces, longwave albedo is 1 - emissivity
-            surfoutll(startenergy:endenergy) = (1._wp - emiss_surf(startenergy:endenergy)) * surfinl(startenergy:endenergy)
-
-#if defined( __parallel )
-            CALL MPI_AllGatherv(surfoutsl, nsurfl, MPI_REAL, &
-                surfouts, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
-            CALL MPI_AllGatherv(surfoutll, nsurfl, MPI_REAL, &
-                surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
-#else
-            surfouts(:) = surfoutsl(:)
-            surfoutl(:) = surfoutll(:)
-#endif
-
-            !-- reset for next pass input
-            surfins(:) = 0._wp
-            surfinl(:) = 0._wp
-            
-            !-- reflected radiation
-            DO isvf = 1, nsvfl
-                isurf = svfsurf(1, isvf)
-                isurfsrc = svfsurf(2, isvf)
-
-                !-- TODO: to remove if, use start+end for isvf
-                IF ( surf(id, isurfsrc) < isky ) THEN
-                    surfins(isurf) = surfins(isurf) + svf(1,isvf) * svf(2,isvf) * surfouts(isurfsrc)
-                    surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
-                ENDIF
-            ENDDO
-
-            !-- radiation absorbed by plant canopy
-            DO isvf = nsvfl+1, nsvfcsfl
-                ipcgb = svfsurf(1, isvf)
-                isurfsrc = svfsurf(2, isvf)
-
-                IF ( surf(id, isurfsrc) < isky ) THEN
-                    pcbinsw(ipcgb) = pcbinsw(ipcgb) + svf(1,isvf) * svf(2,isvf) * surfouts(isurfsrc)
-                    !-- pcbinlw(ipcgb) = pcbinlw(ipcgb) + svf(1,isvf) * surfoutl(isurfsrc)
-                ENDIF
-            ENDDO
-            
-            surfinsw(:) = surfinsw(:)  + surfins(:)
-            surfinlw(:) = surfinlw(:)  + surfinl(:)
-            surfoutsw(startenergy:endenergy) = surfoutsw(startenergy:endenergy) + surfoutsl(startenergy:endenergy)
-            surfoutlw(startenergy:endenergy) = surfoutlw(startenergy:endenergy) + surfoutll(startenergy:endenergy)
-            surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
-                                          - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
-        
-        ENDDO
-
-        !-- push heat flux absorbed by plant canopy to respective 3D arrays
-        IF (plant_canopy) THEN
-            canopy_heat_flux(:,:,:) = 0._wp
-            DO ipcgb = 1, npcbl
-                j = pcbl(iy, ipcgb)
-                i = pcbl(ix, ipcgb)
-                k = pcbl(iz, ipcgb)
-                kk = k - nzb_s_inner(j,i)  !- lad arrays are defined flat
-                canopy_heat_flux(kk, j, i) = (pcbinsw(ipcgb) + pcbinlw(ipcgb)) &
-                    * pchf_prep(k) * pt(k, j, i) !-- = dT/dt
-            ENDDO
-        ENDIF
-
-        !-- return surface radiation to horizontal surfaces 
-        !-- to rad_sw_in, rad_lw_in and rad_net for outputs
-        !!!!!!!!!!
-        !-- we need the original radiation on urban top layer
-        !-- for calculation of MRT so we can't do adjustment here for now
-        !!!!!!!!!!
-        !!!DO isurf = 1, nsurfl
-        !!!    i = surfl(ix,isurf)
-        !!!    j = surfl(iy,isurf)
-        !!!    k = surfl(iz,isurf)
-        !!!    d = surfl(id,isurf)
-        !!!    IF ( d==iroof ) THEN
-        !!!        rad_sw_in(:,j,i) = surfinsw(isurf)
-        !!!        rad_lw_in(:,j,i) = surfinlw(isurf)
-        !!!        rad_net(j,i) = rad_sw_in(k,j,i) - rad_sw_out(k,j,i) + rad_lw_in(k,j,i) - rad_lw_out(k,j,i)
-        !!!    ENDIF
-        !!!ENDDO
-
-    END SUBROUTINE usm_radiation
-
-    
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> This subroutine splits direct and diffusion dw radiation
-!> It sould not be called in case the radiation model already does it
-!> It follows <CITATION>
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_calc_diffusion_radiation 
-    
-        REAL(wp), PARAMETER                          ::  sol_const = 1367.0_wp   !< solar conbstant
-        REAL(wp), PARAMETER                          :: lowest_solarUp = 0.1_wp  !< limit the sun elevation to protect stability of the calculation
-        INTEGER(iwp)                                 :: i, j
-        REAL(wp), PARAMETER                          ::  year_seconds = 86400._wp * 365._wp
-        REAL(wp)                                     ::  year_angle              !< angle
-        REAL(wp)                                     ::  etr                     !< extraterestrial radiation
-        REAL(wp)                                     ::  corrected_solarUp       !< corrected solar up radiation
-        REAL(wp)                                     ::  horizontalETR           !< horizontal extraterestrial radiation
-        REAL(wp)                                     ::  clearnessIndex          !< clearness index
-        REAL(wp)                                     ::  diff_frac               !< diffusion fraction of the radiation
-
-        
-        !
-        !-- Calculate current day and time based on the initial values and simulation time
-        year_angle = ((day_init*86400) + time_utc_init+time_since_reference_point) &
-                       / year_seconds * 2.0_wp * pi
-        
-        etr = sol_const * (1.00011_wp +                                            &
-                          0.034221_wp * cos(year_angle) +                          &
-                          0.001280_wp * sin(year_angle) +                          &
-                          0.000719_wp * cos(2.0_wp * year_angle) +                 &
-                          0.000077_wp * sin(2.0_wp * year_angle))
-        
-        !--
-        !-- Under a very low angle, we keep extraterestrial radiation at
-        !-- the last small value, therefore the clearness index will be pushed
-        !-- towards 0 while keeping full continuity.
-        !--
-        IF ( zenith(0) <= lowest_solarUp ) THEN
-            corrected_solarUp = lowest_solarUp
-        ELSE
-            corrected_solarUp = zenith(0)
-        ENDIF
-        
-        horizontalETR = etr * corrected_solarUp
-        
-        DO i = nxlg, nxrg
-            DO j = nysg, nyng
-                clearnessIndex = rad_sw_in(0,j,i) / horizontalETR
-                diff_frac = 1.0_wp / (1.0_wp + exp(-5.0033_wp + 8.6025_wp * clearnessIndex))
-                rad_sw_in_diff(j,i) = rad_sw_in(0,j,i) * diff_frac
-                rad_sw_in_dir(j,i)  = rad_sw_in(0,j,i) * (1.0_wp - diff_frac)
-                rad_lw_in_diff(j,i) = rad_lw_in(0,j,i)
-            ENDDO
-        ENDDO
-        
-    END SUBROUTINE usm_calc_diffusion_radiation
-    
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Solver for the energy balance at the ground/roof/wall surface.
-!> It follows basic ideas and structure of lsm_energy_balance
-!> with many simplifications and adjustments.
-!> TODO better description
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_surface_energy_balance
-
-        IMPLICIT NONE
-
-        INTEGER(iwp)                          :: i, j, k, l, d      ! running indices
-        
-        REAL(wp)                              :: pt1                ! temperature at first grid box adjacent to surface
-        REAL(wp)                              :: u1,v1,w1           ! near wall u,v,w
-        REAL(wp)                              :: stend              ! surface tendency
-        REAL(wp)                              :: coef_1             ! first coeficient for prognostic equation
-        REAL(wp)                              :: coef_2             ! second  coeficient for prognostic equation
-        REAL(wp)                              :: rho_cp             ! rho_wall_surface * cp
-        REAL(wp)                              :: r_a                ! aerodynamic resistance for horizontal and vertical surfaces
-        REAL(wp)                              :: f_shf              ! factor for shf_eb
-        REAL(wp)                              :: lambda_surface     ! current value of lambda_surface (heat conductivity between air and wall)
-        REAL(wp)                              :: Ueff               ! effective wind speed for calculation of heat transfer coefficients
-        REAL(wp)                              :: httc               ! heat transfer coefficient
-        REAL(wp), DIMENSION(nzub:nzut)        :: exn                ! value of the Exner function in layers
-        
-        REAL(wp), DIMENSION(0:4)              :: dxdir              ! surface normal direction gridbox length
-        REAL(wp)                              :: dtime              ! simulated time of day (in UTC)
-        INTEGER(iwp)                          :: dhour              ! simulated hour of day (in UTC)
-        REAL(wp)                              :: acoef              ! actual coefficient of diurnal profile of anthropogenic heat
-
-        dxdir = (/dz,dy,dy,dx,dx/)
-        
-        exn(:) = (hyp(nzub:nzut) / 100000.0_wp )**0.286_wp          !< Exner function
-            
-        !--
-        DO l = startenergy, endenergy
-            !--    Calculate frequently used parameters
-            d = surfl(id,l)
-            k = surfl(iz,l)
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-
-            !-- TODO - how to calculate lambda_surface for horizontal surfaces
-            !-- (lambda_surface is set according to stratification in land surface model)
-            IF ( ol(j,i) >= 0.0_wp )  THEN
-                lambda_surface = lambda_surf(l)
-            ELSE
-                lambda_surface = lambda_surf(l)
-            ENDIF
-            
-            pt1  = pt(k,j,i)
-
-            ! calculate rho * cp coefficient at surface layer
-            rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
-
-            ! calculate aerodyamic resistance. 
-            IF ( d == iroof ) THEN
-                !-- calculation for horizontal surfaces follows LSM formulation
-                !-- pt, us, ts are not available for the prognostic time step,
-                !-- data from the last time step is used here.
-                
-                r_a = (pt1 - t_surf(l)/exn(k)) / (ts(j,i) * us(j,i) + 1.0E-10_wp)
-                
-                !-- make sure that the resistance does not drop to zero
-                IF ( ABS(r_a) < 1.0E-10_wp )  r_a = 1.0E-10_wp
-                
-                !!!!!!!!!!!!!!!!!!!!
-                !-- the parameterization is developed originally for larger scales
-                !-- (compare with remark in TUF-3D)
-                !-- our first experiences show that the parameterization underestimates
-                !-- r_a in meter resolution.
-                !-- temporary solution - multiplication by magic constant :-(.
-                r_a = r_a * ra_horiz_coef
-                
-                !-- factor for shf_eb
-                f_shf  = rho_cp / r_a
-                IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                    WRITE(9,'(f8.1,2i3,a,4i3,100000g20.5)') simulated_time,intermediate_timestep_count,myid,'wall_f_shf ', &
-                             i,j,k,d,f_shf, r_a,ra_horiz_coef,pt1,t_surf(l)/exn(k), ts(j,i), us(j,i)
-                    FLUSH(9)
-                ENDIF
-            ELSE
-                
-                !-- calculation of r_a for vertical surfaces
-                !--
-                !-- heat transfer coefficient for forced convection along vertical walls
-                !-- follows formulation in TUF3d model (Krayenhoff & Voogt, 2006)
-                !--
-                !-- H = httc (Tsfc - Tair)
-                !-- httc = rw * (11.8 + 4.2 * Ueff) - 4.0
-                !--
-                !--       rw: wall patch roughness relative to 1.0 for concrete
-                !--       Ueff: effective wind speed
-                !--       - 4.0 is a reduction of Rowley et al (1930) formulation based on
-                !--       Cole and Sturrock (1977)
-                !
-                !--       Ucan: Canyon wind speed
-                !--       wstar: convective velocity
-                !--       Qs: surface heat flux
-                !--       zH: height of the convective layer
-                !--       wstar = (g/Tcan*Qs*zH)**(1./3.)
-                
-                !-- staggered grid needs to be taken into consideration
-                IF ( d == inorth ) THEN
-                    u1 = (u(k,j,i)+u(k,j,i+1))*0.5_wp
-                    v1 = v(k,j+1,i)
-                ELSE IF ( d == isouth ) THEN
-                    u1 = (u(k,j,i)+u(k,j,i+1))*0.5_wp
-                    v1 = v(k,j,i)
-                ELSE IF ( d == ieast ) THEN
-                    u1 = u(k,j,i+1)
-                    v1 = (v(k,j,i)+v(k,j+1,i))*0.5_wp
-                ELSE IF ( d == iwest ) THEN
-                    u1 = u(k,j,i)
-                    v1 = (v(k,j,i)+v(k,j+1,i))*0.5_wp
-                ELSE
-                    STOP
-                ENDIF
-                w1 = (w(k,j,i)+w(k-1,j,i))*0.5_wp
-                
-                Ueff = SQRT(u1**2 + v1**2 + w1**2)
-
-                httc = roughness_wall(l) * (11.8 + 4.2 * Ueff) - 4.0
-
-                f_shf  = httc
-                IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                    WRITE(9,'(f8.1,2i3,a,4i3,100000g20.5)') simulated_time,intermediate_timestep_count,myid,'wall_f_shf ', &
-                         i,j,k,d,f_shf, Ueff, roughness_wall(l), pt1, t_surf(l)/exn(k)
-                    FLUSH(9)
-                ENDIF
-            ENDIF
-        
-            !-- add LW up so that it can be removed in prognostic equation
-            rad_net_l(l) = surfinsw(l) - surfoutsw(l) + surfinlw(l) - surfoutlw(l)
-
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000f20.5)') simulated_time, intermediate_timestep_count, myid, 'wallrad ',           &
-                          i,j,k,d, rad_net_l(l), surfinsw(l), -surfoutsw(l), surfinlw(l), -surfoutlw(l), t_surf(l)
-                FLUSH(9)
-            ENDIF
-            !-- numerator of the prognostic equation
-            coef_1 = rad_net_l(l) +    &    !!!! coef +1 corresponds to -lwout included in calculation of radnet_l
-                     (3.0_wp+1.0_wp) * emiss_surf(l) * sigma_sb * t_surf(l) ** 4 +      &  
-                     f_shf  * pt1 +                                                     &
-                     lambda_surface * t_wall(nzb_wall,l)
-
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000g20.5)') simulated_time,intermediate_timestep_count,myid,'wallcoef1 ', &
-                         i,j,k,d, coef_1,rad_net_l(l),emiss_surf(l),sigma_sb, t_surf(l), &
-                         f_shf, pt1, lambda_surface, t_wall(nzb_wall,l)
-                FLUSH(9)
-            ENDIF
-            
-            !-- denominator of the prognostic equation
-            coef_2 = 4.0_wp * emiss_surf(l) * sigma_sb * t_surf(l) ** 3     &
-                         + lambda_surface + f_shf / exn(k)
-                                
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000g20.5)') simulated_time,intermediate_timestep_count,myid,'wallcoef2 ',&
-                         i,j,k,d, coef_2, emiss_surf(l), sigma_sb, t_surf(l), lambda_surface, f_shf
-                FLUSH(9)
-            ENDIF
-
-            !-- implicit solution when the surface layer has no heat capacity,
-            !-- otherwise use RK3 scheme.
-            t_surf_p(l) = ( coef_1 * dt_3d * tsc(2) + c_surface(l) * t_surf(l) ) /           & 
-                              ( c_surface(l) + coef_2 * dt_3d * tsc(2) ) 
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000g20.5)') simulated_time,intermediate_timestep_count,myid,'walltsurf ', &
-                          i,j,k,d, t_surf_p(l), coef_1, dt_3d, tsc(2), c_surface(l), t_surf(l), coef_2, dt_3d
-                FLUSH(9)
-            ENDIF
-
-            !-- add RK3 term
-            t_surf_p(l) = t_surf_p(l) + dt_3d * tsc(3) * tt_surface_m(l)
-            
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000f20.5)') simulated_time,intermediate_timestep_count,myid,'t_surf_p_wall3 ', &
-                        i,j,k,d,t_surf_p(l), dt_3d, tsc(3), tt_surface_m(l)
-                FLUSH(9)
-            ENDIF
-        
-            !-- calculate true tendency
-            stend = (t_surf_p(l) - t_surf(l) - dt_3d * tsc(3) * tt_surface_m(l)) / (dt_3d  * tsc(2))
-
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000f20.5)') simulated_time,intermediate_timestep_count,myid,'t_surf_p_tend ', &
-                         i,j,k,d,stend,t_surf_p(l),t_surf(l), dt_3d, tsc(3), tt_surface_m(l), tsc(2)
-                FLUSH(9)
-            ENDIF
-
-            !-- calculate t_surf tendencies for the next Runge-Kutta step
-            IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                    tt_surface_m(l) = stend
-                ELSEIF ( intermediate_timestep_count <                         &
-                         intermediate_timestep_count_max )  THEN
-                    tt_surface_m(l) = -9.5625_wp * stend + 5.3125_wp            &
-                                       * tt_surface_m(l)
-                ENDIF
-            ENDIF
-
-            !-- in case of fast changes in the skin temperature, it is required to
-            !-- update the radiative fluxes in order to keep the solution stable
-            IF ( ABS( t_surf_p(l) - t_surf(l) ) > 1.0_wp )  THEN
-               force_radiation_call_l = .TRUE.
-            ENDIF
-            
-            !-- for horizontal surfaces is pt(nzb_s_inner(j,i),j,i) = pt_surf.
-            !-- there is no equivalent surface gridpoint for vertical surfaces.
-            !-- pt(k,j,i) is calculated for all directions in diffusion_s
-            !-- using surface and wall heat fluxes
-            IF ( d == iroof ) THEN
-               pt(nzb_s_inner(j,i),j,i) = t_surf_p(l) / exn(k)
-            ENDIF
-
-            !-- calculate fluxes
-            !-- rad_net_l is never used!!            
-            rad_net_l(l)     = rad_net_l(l) + 3.0_wp * sigma_sb                &
-                                * t_surf(l)**4 - 4.0_wp * sigma_sb             &
-                                * t_surf(l)**3 * t_surf_p(l)
-            wghf_eb(l)       = lambda_surface * (t_surf_p(l) - t_wall(nzb_wall,l))
-
-            !-- ground/wall/roof surface heat flux
-            wshf_eb(l)  = - f_shf  * ( pt1 - t_surf_p(l) )
-            
-            !-- store kinematic surface heat fluxes for utilization in other processes
-            !-- diffusion_s, surface_layer_fluxes,...
-            IF ( d == iroof ) THEN
-                !-- shf is used in diffusion_s and also
-                !-- for calculation of surface layer fluxes
-                !-- update for horizontal surfaces
-                shf(j,i) = wshf_eb(l) / rho_cp
-            ELSE
-                !-- surface heat flux for vertical surfaces
-                !-- used in diffusion_s
-                wshf(l) = wshf_eb(l) / rho_cp
-            ENDIF
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000f20.5)') simulated_time,   &
-                          intermediate_timestep_count, myid, 'shf2 ',         &
-                          i,j,k,d, pt1, t_surf_p(l), stend, rho_cp, wshf_eb(l)/rho_cp, wshf_eb(l), &
-                          wghf_eb(l), lambda_surface, t_wall(nzb_wall,l)
-                FLUSH(9)
-            ENDIF
-
-        ENDDO
-        
-        
-        IF ( usm_anthropogenic_heat .AND. &
-             intermediate_timestep_count == intermediate_timestep_count_max ) THEN
-            !-- application of the additional anthropogenic heat sources
-            !-- we considere the traffic for now so all heat is absorbed
-            !-- to the first layer, generalization would be worth
-            
-            !-- calculation of actual profile coefficient
-            !-- ??? check time_since_reference_point ???
-            dtime = mod(simulated_time + time_utc_init, 24.0_wp*3600.0_wp)
-            dhour = INT(dtime/3600.0_wp)
-            !-- linear interpolation of coeficient
-            acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(dhour) + (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(dhour+1)
-            DO i = nxl, nxr
-                DO j = nys, nyn
-                    IF ( aheat(j,i) > 0.0_wp ) THEN
-                        !-- TODO the increase of pt in box i,j,nzb_s_inner(j,i)+1 in time dt_3d 
-                        !-- given to anthropogenic heat aheat*acoef (W*m-2)
-                        !-- k = nzb_s_inner(j,i)+1
-                        !-- pt(k,j,i) = pt(k,j,i) + aheat(j,i)*acoef*dt_3d/(exn(k)*rho_cp*dz)
-                        !-- Instead of this, we can adjust shf in case AH only at surface
-                        shf(j,i) = shf(j,i) + aheat(j,i)*acoef * ddx * ddy / rho_cp
-                        IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                            WRITE(9,'(f8.1,i3,a,3i3,100000f20.5)') simulated_time,  myid, 'ah1 ',     &
-                                      i,j,k,shf(j,i), aheat(j,i)*acoef*ddx*ddy/rho_cp, &
-                                      aheat(j,i),acoef, ddx,ddy,rho_cp
-                            FLUSH(9)
-                        ENDIF
-                    ENDIF
-                ENDDO
-            ENDDO
-        ENDIF
-        
-        !-- pt and shf are defined on nxlg:nxrg,nysg:nyng
-        !-- get the borders from neighbours
-        CALL exchange_horiz( pt, nbgp )
-        CALL exchange_horiz_2d( shf )
-
-
-       !-- calculation of force_radiation_call:
-       !-- Make logical OR for all processes.
-       !-- Force radiation call if at least one processor forces it.
-       IF ( intermediate_timestep_count == intermediate_timestep_count_max-1 ) &
-       THEN
-#if defined( __parallel )
-          IF ( collective_wait )  CALL mpi_barrier( comm2d, ierr )
-              CALL mpi_allreduce( force_radiation_call_l, force_radiation_call,    &
-                                  1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
-#else
-          force_radiation_call = force_radiation_call_l
-#endif
-          force_radiation_call_l = .FALSE.
-       ENDIF
-
-
-    END SUBROUTINE usm_surface_energy_balance
-
-
+ 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !
-!> Wall model as part of the urban surface model. The model predicts wall
-!> temperature.
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_material_heat_model
-
-
-        IMPLICIT NONE
-
-        INTEGER(iwp) ::  i,j,k,l,kw                      !< running indices
-
-        REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wtend  !< tendency
-
-                                               
-        DO l = startenergy, endenergy
-            !-- calculate frequently used parameters
-            k = surfl(iz,l)
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-
-            !
-            !-- prognostic equation for ground/wall/roof temperature t_wall
-            wtend(:) = 0.0_wp
-            wtend(nzb_wall) = (1.0_wp/rho_c_wall(nzb_wall,l)) *                     &
-                       ( lambda_h(nzb_wall,l) * ( t_wall(nzb_wall+1,l)              &
-                         - t_wall(nzb_wall,l) ) * ddz_wall(nzb_wall+1,l)            &
-                         + wghf_eb(l) ) * ddz_wall_stag(nzb_wall,l)
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,4i3,100000g12.5)') simulated_time,intermediate_timestep_count, &
-                                    myid,'wallmodel1b ',                            &
-                                    i,j,k,nzb_wall,wtend(nzb_wall),                 &
-                                    t_wall(nzb_wall+1,l), t_wall(nzb_wall,l),       &
-                                    wghf_eb(l),                                     &
-                                    dz_wall(nzb_wall,l), dz_wall_stag(nzb_wall,l),  &
-                                    lambda_h(nzb_wall,l)
-                FLUSH(9)
+!> This subroutine is part of the urban surface model.
+!> It reads daily heat produced by anthropogenic sources
+!> and the diurnal cycle of the heat.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_read_anthropogenic_heat
+    
+        INTEGER(iwp)                  :: i,j,ii
+        REAL(wp)                      :: heat
+        
+!--     allocation of array of sources of anthropogenic heat and their diural profile
+        ALLOCATE( aheat(nys:nyn,nxl:nxr) )
+        ALLOCATE( aheatprof(0:24) )
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     read daily amount of heat and its daily cycle
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        aheat = 0.0_wp
+        DO  ii = 0, io_blocks-1
+            IF ( ii == io_group )  THEN
+
+!--             open anthropogenic heat file 
+                OPEN( 151, file='ANTHROPOGENIC_HEAT'//TRIM(coupling_char), action='read', &
+                           status='old', form='formatted', err=11 )
+                i = 0
+                j = 0
+                DO
+                    READ( 151, *, err=12, end=13 )  i, j, heat
+                    IF ( i >= nxl  .AND.  i <= nxr  .AND.  j >= nys  .AND.  j <= nyn )  THEN
+!--                     write heat into the array
+                        aheat(j,i) = heat
+                    ENDIF
+                    CYCLE
+ 12                 WRITE(message_string,'(a,2i4)') 'error in file ANTHROPOGENIC_HEAT'//TRIM(coupling_char)//' after line ',i,j
+                    CALL message( 'usm_read_anthropogenic_heat', 'PA0515', 0, 1, 0, 6, 0 )
+                ENDDO
+ 13             CLOSE(151)
+                CYCLE
+ 11             message_string = 'file ANTHROPOGENIC_HEAT'//TRIM(coupling_char)//' does not exist'
+                CALL message( 'usm_read_anthropogenic_heat', 'PA0516', 1, 2, 0, 6, 0 )
             ENDIF
             
-            DO  kw = nzb_wall+1, nzt_wall
-                wtend(kw) = (1.0_wp/rho_c_wall(kw,l))                               &
-                              * (   lambda_h(kw,l)                                  &
-                                 * ( t_wall(kw+1,l) - t_wall(kw,l) )                &
-                                 * ddz_wall(kw+1,l)                                 &
-                              - lambda_h(kw-1,l)                                    &
-                                 * ( t_wall(kw,l) - t_wall(kw-1,l) )                &
-                                 * ddz_wall(kw,l)                                   &
-                              ) * ddz_wall_stag(kw,l)
-                IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                    WRITE(9,'(f8.1,2i3,a,4i3,100000g12.5)') simulated_time,intermediate_timestep_count,&
-                                    myid,'wallmodel1c ',                            &
-                                    i,j,k,kw,wtend(kw),                             &
-                                    t_wall(kw+1,l), t_wall(kw,l), t_wall(kw-1,l),   &
-                                    dz_wall(kw,l), dz_wall_stag(kw,l),              &
-                                    lambda_h(kw,l)
-                    FLUSH(9)
-                ENDIF
-            ENDDO
-
-            t_wall_p(nzb_wall:nzt_wall,l) = t_wall(nzb_wall:nzt_wall,l)             &
-                                             + dt_3d * ( tsc(2)                     &
-                                             * wtend(nzb_wall:nzt_wall) + tsc(3)    &
-                                             * tt_wall_m(nzb_wall:nzt_wall,l) )   
-            IF ( debug_prints  .AND.  time_do3d < dt_3d )  THEN
-                WRITE(9,'(f8.1,2i3,a,3i3,100000g15.5)') simulated_time,intermediate_timestep_count,&
-                                    myid,'wallmodel2 ',                             &
-                                    i,j,k,                                          &
-                                    t_wall_p(nzb_wall,l),t_wall(nzb_wall,l),        &
-                                    wtend(nzb_wall), tt_wall_m(nzb_wall,l)
-                FLUSH(9)
+#if defined( __parallel ) && ! defined ( __check )
+            CALL mpi_barrier( comm2d, ierr )
+#endif
+        ENDDO
+        
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     read diurnal profiles of heat sources
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        aheatprof = 0.0_wp
+        DO  ii = 0, io_blocks-1
+            IF ( ii == io_group )  THEN
+
+!--             open anthropogenic heat profile file 
+                OPEN( 151, file='ANTHROPOGENIC_HEAT_PROFILE'//TRIM(coupling_char), action='read', &
+                           status='old', form='formatted', err=21 )
+                i = 0
+                DO
+                    READ( 151, *, err=22, end=23 )  i, heat
+                    IF ( i >= 0  .AND.  i <= 24 )  THEN
+!--                     write heat into the array
+                        aheatprof(i) = heat
+                    ENDIF
+                    CYCLE
+ 22                 WRITE(message_string,'(a,i4)') 'error in file ANTHROPOGENIC_HEAT_PROFILE'// &
+                                                     TRIM(coupling_char)//' after line ',i
+                    CALL message( 'usm_read_anthropogenic_heat', 'PA0517', 0, 1, 0, 6, 0 )
+                ENDDO
+                aheatprof(24) = aheatprof(0)
+ 23             CLOSE(151)
+                CYCLE
+ 21             message_string = 'file ANTHROPOGENIC_HEAT_PROFILE'//TRIM(coupling_char)//' does not exist'
+                CALL message( 'usm_read_anthropogenic_heat', 'PA0518', 1, 2, 0, 6, 0 )
             ENDIF
             
-            !
-            !-- calculate t_wall tendencies for the next Runge-Kutta step
-            IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  kw = nzb_wall, nzt_wall
-                      tt_wall_m(kw,l) = wtend(kw)
-                   ENDDO
-                ELSEIF ( intermediate_timestep_count <                              &
-                         intermediate_timestep_count_max )  THEN
-                    DO  kw = nzb_wall, nzt_wall
-                        tt_wall_m(kw,l) = -9.5625_wp * wtend(kw) + 5.3125_wp        &
-                                         * tt_wall_m(kw,l)
-                    ENDDO
-                ENDIF
-            ENDIF
+#if defined( __parallel ) && ! defined ( __check )
+            CALL mpi_barrier( comm2d, ierr )
+#endif
         ENDDO
-
-    END SUBROUTINE usm_material_heat_model
-
-!------------------------------------------------------------------------------!
+        
+    END SUBROUTINE usm_read_anthropogenic_heat
+   
+
+!------------------------------------------------------------------------------!
+!
 ! Description:
 ! ------------
+!> Soubroutine reads t_surf and t_wall data from restart files
+!kanani: Renamed this routine according to corresponging routines in PALM
+!kanani: Modified the routine to match read_var_list, from where usm_read_restart_data
+!        shall be called in the future. This part has not been tested yet. (see virtual_flight_mod)
+!        Also, I had some trouble with the allocation of t_surf, since this is a pointer.
+!        So, I added some directives here.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_read_restart_data
+
+
+       IMPLICIT NONE
+       
+       CHARACTER (LEN=30) ::  variable_chr  !< dummy variable to read string
+       
+       INTEGER            ::  i             !< running index      
+       
+
+       DO  i = 0, io_blocks-1
+          IF ( i == io_group )  THEN
+             READ ( 13 )  variable_chr
+             DO   WHILE ( TRIM( variable_chr ) /= '*** end usm ***' )
+
+                SELECT CASE ( TRIM( variable_chr ) )
+                
+                   CASE ( 't_surf' )
+#if defined( __nopointer )                   
+                      IF ( .NOT.  ALLOCATED( t_surf ) )                         &
+                         ALLOCATE( t_surf(startenergy:endenergy) )
+                      READ ( 13 )  t_surf
+#else                      
+                      IF ( .NOT.  ALLOCATED( t_surf_1 ) )                         &
+                         ALLOCATE( t_surf_1(startenergy:endenergy) )
+                      READ ( 13 )  t_surf_1
+#endif
+
+                   CASE ( 't_wall' )
+#if defined( __nopointer )
+                      IF ( .NOT.  ALLOCATED( t_wall ) )                         &
+                         ALLOCATE( t_wall(nzb_wall:nzt_wall+1,startenergy:endenergy) )
+                      READ ( 13 )  t_wall
+#else
+                      IF ( .NOT.  ALLOCATED( t_wall_1 ) )                         &
+                         ALLOCATE( t_wall_1(nzb_wall:nzt_wall+1,startenergy:endenergy) )
+                      READ ( 13 )  t_wall_1
+#endif
+
+                   CASE DEFAULT
+                      WRITE ( message_string, * )  'unknown variable named "', &
+                                        TRIM( variable_chr ), '" found in',    &
+                                        '&data from prior run on PE ', myid
+                      CALL message( 'user_read_restart_data', 'UI0012', 1, 2, 0, 6, 0 )
+
+                END SELECT
+
+                READ ( 13 )  variable_chr
+
+             ENDDO
+          ENDIF
+#if defined( __parallel )
+          CALL MPI_BARRIER( comm2d, ierr )
+#endif
+       ENDDO
+
+    END SUBROUTINE usm_read_restart_data
+
+
+!------------------------------------------------------------------------------!
 !
-!> This function applies the kinematic wall heat fluxes
-!> for walls in four directions for all gridboxes in urban layer.
-!> It is called out from subroutine prognostic_equations.
-!> TODO Compare performance with cycle runnig l=startwall,endwall...
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_wall_heat_flux
-    
-        IMPLICIT NONE
-
-        INTEGER(iwp)              ::  i,j,k,d,l             !< running indices
-        
-!        DO i = nxl, nxr
-!            DO j = nys, nyn
-!                DO k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
-!                    DO d = 1,4
-!                        l = gridsurf(d,k,j,i)
-!                        IF ( l /= 0 ) THEN
-!                            tend(k,j,i) = tend(k,j,i) + wshf(l) * ddxy2(d)
-!                        ENDIF
-!                    ENDDO
-!                ENDDO
-!            ENDDO
-!        ENDDO
-
-!ketelsen:     To spare the 4 Dimensional array gridsurf, the complete l-loop is executed for every i and j value
-!ketelsen:     This is not very elegant, but also not time critical
-        DO l = startenergy, endenergy
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-            k = surfl(iz,l)
-            d = surfl(id,l)
-            tend(k,j,i) = tend(k,j,i) + wshf(l) * ddxy2(d)
-        ENDDO
-
-    END SUBROUTINE usm_wall_heat_flux
- 
- 
-!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!
-!> This function applies the kinematic wall heat fluxes
-!> for walls in four directions around the gridbox i,j.
-!> It is called out from subroutine prognostic_equations.
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_wall_heat_flux_ij(i,j) 
-    
+!> Soubroutine reads svf and svfsurf data from saved file
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_read_svf_from_file
+
         IMPLICIT NONE
-
-        INTEGER(iwp), INTENT(in)  ::  i,j                   !< indices of grid box
-        INTEGER(iwp)              ::  ii,jj,k,d,l
-        
-!        DO k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
-!            DO d = 1,4
-!                l = gridsurf(d,k,j,i)
-!                IF ( l /= 0 ) THEN
-!                    tend(k,j,i) = tend(k,j,i) + wshf(l) * ddxy2(d)
-!                ENDIF
-!            ENDDO
-!        ENDDO
-
-
-!ketelsen:     To spare the 4 Dimensional array gridsurf, the complete l-loop is executed for every i and j value
-!ketelsen:     This is not very elegant, but also not time critical
-
-        DO l = startenergy, endenergy
-            jj = surfl(iy,l)
-            ii = surfl(ix,l)
-            IF( ii == i .AND. jj == j) then
-               k = surfl(iz,l)
-               IF(k >=  nzb_s_inner(j,i)+1 .AND. k <=  nzb_s_outer(j,i)) then
-                  d = surfl(id,l)
-                  if(d >= 1 .and. d <= 4)   then
-                     tend(k,j,i) = tend(k,j,i) + wshf(l) * ddxy2(d)
-                  end if
-               ENDIF
+        INTEGER                      :: fsvf = 89
+        INTEGER                      :: i
+        CHARACTER(usm_version_len)   :: usm_version_field
+        CHARACTER(svf_code_len)      :: svf_code_field
+
+        DO  i = 0, io_blocks-1
+            IF ( i == io_group )  THEN
+                OPEN ( fsvf, file=TRIM(svf_file_name)//TRIM(coupling_char)//myid_char,               &
+                    form='unformatted', status='old' )
+
+!--             read and check version
+                READ ( fsvf ) usm_version_field
+                IF ( TRIM(usm_version_field) /= TRIM(usm_version) )  THEN
+                    WRITE( message_string, * ) 'Version of binary SVF file "',           &
+                                            TRIM(usm_version_field), '" does not match ',            &
+                                            'the version of model "', TRIM(usm_version), '"'
+                    CALL message( 'usm_read_svf_from_file', 'UI0012', 1, 2, 0, 6, 0 )
+                ENDIF
+                
+!--             read nsvfcsfl, nsvfl
+                READ ( fsvf ) nsvfcsfl, nsvfl
+                IF ( nsvfcsfl <= 0 )  THEN
+                    WRITE( message_string, * ) 'Wrong number of SVF or CSF'
+                    CALL message( 'usm_read_svf_from_file', 'UI0012', 1, 2, 0, 6, 0 )
+                ELSE
+                    WRITE(message_string,*) '    Number of SVF and CSF to read', nsvfcsfl, nsvfl
+                    CALL location_message( message_string, .TRUE. )
+                ENDIF
+                
+                ALLOCATE(svf(ndsvf,nsvfcsfl))
+                ALLOCATE(svfsurf(ndsvf,nsvfcsfl))
+                
+                READ(fsvf) svf
+                READ(fsvf) svfsurf
+                READ ( fsvf ) svf_code_field
+                
+                IF ( TRIM(svf_code_field) /= TRIM(svf_code) )  THEN
+                    WRITE( message_string, * ) 'Wrong structure of binary svf file'
+                    CALL message( 'usm_read_svf_from_file', 'UI0012', 1, 2, 0, 6, 0 )
+                ENDIF
+                
+                CLOSE (fsvf)
+                
             ENDIF
+#if defined( __parallel )
+            CALL mpi_barrier( comm2d, ierr )
+#endif
         ENDDO
 
-    END SUBROUTINE usm_wall_heat_flux_ij
- 
-   
+    END SUBROUTINE usm_read_svf_from_file
+
     
 !------------------------------------------------------------------------------!
